| LiquidMenu 1.3.0 Menu creation Arduino library for LCDs, wraps LiquidCrystal.

Classes | Macros | Enumerations | Functions | Variables
LiquidMenu.h File Reference
`#include <inttypes.h>`
`#include <avr/pgmspace.h>`
`#include <stdio.h>`
`#include <stdlib.h>`
`#include "LiquidMenu_config.h"`
`#include "LiquidMenu_debug.h"`
`#include <LiquidCrystal.h>`

Go to the source code of this file.

## Classes
class | LiquidLine
| Represents the individual lines printed on the display. More...
class | LiquidScreen
| Represents a screen shown on the display. More...
class | LiquidMenu
| Represents a collection of screens forming a menu. More...
class | LiquidSystem
| Represents a collection of menus forming a menu system. More...

## Macros
#define | DisplayClass LiquidCrystal

## Enumerations
enum | DataType : uint8_t { NOT_USED = 0, BOOL = 1, BOOLEAN = 1, INT8_T = 8, UINT8_T = 9, BYTE = 9, INT16_T = 16, UINT16_T = 17, INT32_T = 32, UINT32_T = 33, FLOAT = 50, DOUBLE = 50, CHAR = 60, CHAR_PTR = 61, CONST_CHAR_PTR = 62, PROG_CONST_CHAR_PTR = 65, GLYPH = 70 }
| Data type enum. More...
enum | Position : uint8_t { RIGHT = 1, NORMAL = 1, LEFT = 2, CUSTOM = 3 }
| Position enum. More...

## Functions
void | print_me (uintptr_t address)
| Prints the number passed to it in a specific way. More...
recognizeType overloaded function
DataType | recognizeType (bool variable)
DataType | recognizeType (char variable)
DataType | recognizeType (char *variable)
DataType | recognizeType (const char *variable)
DataType | recognizeType (int8_t variable)
DataType | recognizeType (uint8_t variable)
DataType | recognizeType (int16_t variable)
DataType | recognizeType (uint16_t variable)
DataType | recognizeType (int32_t variable)
DataType | recognizeType (uint32_t variable)
DataType | recognizeType (float variable)
DataType | recognizeType (double variable)

## Variables
const char | LIQUIDMENU_VERSION [] = "1.3"
| The version of the library. More...

## Detailed Description

Include file for LiquidMenu library.

Author
  Vasil Kalchev

Date
  2016

Version
  1.3.0

Copyright
  The MIT License

Todo:

  : Change/Remove variables/screens/menus maybe

  : screen wide glyphs

  : dynamic memory

  : variadic templates

## Enumeration Type Documentation

## § DataType

enum DataType : uint8_t
| strong

Data type enum.

Used to store the data type of `void*` so that they can be cast back later.

## § Position

enum Position : uint8_t
| strong

Position enum.

## Function Documentation

## § print_me()

void print_me | ( | uintptr_t | address | ) |

Prints the number passed to it in a specific way.

Used for convenience when printing the class's address for indentification.

Parameters

  address | - number to be printed

## § recognizeType() [1/12]

DataType recognizeType | ( | bool | variable | ) |

Used to recognize the data type of a variable received in a template function.

See also
  DataType

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [2/12]

DataType recognizeType | ( | char | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [3/12]

DataType recognizeType | ( | char * | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [4/12]

DataType recognizeType | ( | const char * | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [5/12]

DataType recognizeType | ( | int8_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [6/12]

DataType recognizeType | ( | uint8_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [7/12]

DataType recognizeType | ( | int16_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [8/12]

DataType recognizeType | ( | uint16_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [9/12]

DataType recognizeType | ( | int32_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [10/12]

DataType recognizeType | ( | uint32_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [11/12]

DataType recognizeType | ( | float | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## § recognizeType() [12/12]

DataType recognizeType | ( | double | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## Variable Documentation

## § LIQUIDMENU_VERSION

const char LIQUIDMENU_VERSION[] = "1.3"

The version of the library.